Unit fta6r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure fta6r(var ARRAY_ :Array of Real; NDIM :Integer;
                var MESH :Array of Integer; IREG :Integer);

implementation

procedure fta6r(var ARRAY_ :Array of Real; NDIM :Integer;
                var MESH :Array of Integer; IREG :Integer);
var
IDIM,NTOT,NPREV,N,NREM,IP1,IP2,IP3,I2REV,I2,I1,I2IP1,I3REV,I3,IBIT,
IFP1,IFP2,I3IP1,K1,K2 :Integer;
TEMPR,TEMPI,TEMP :Real;
WR,WI,WPR,WPI,WTEMP,THETA :Extended;
const
SYS003 :Extended = 6.2831853071795864769252867665590;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,_160;
begin
NTOT := 1;
for IDIM:=1 to NDIM do
 begin
  NTOT := Trunc( NTOT*MESH[IDIM-1] );
_10:
 end;
NPREV := 1;
for IDIM:=1 to NDIM do
 begin
  N := MESH[IDIM-1];
  NREM := Trunc( NTOT/(N*NPREV) );
  IP1 := Trunc( 2*NPREV );
  IP2 := Trunc( IP1*N );
  IP3 := Trunc( IP2*NREM );
  I2REV := 1;
  I2 := 1;
  while ( I2<=IP2 ) do
   begin
    if ( I2 >= I2REV ) 
     then goto _40;
    I2IP1 := I2+IP1-2;
    I1 := I2;
    while ( I1<=I2IP1 ) do
     begin
      I3 := I1;
      while ( I3<=IP3 ) do
       begin
        I3REV := I2REV+I3-I2;
        TEMPR := ARRAY_[I3-1];
        TEMPI := ARRAY_[I3+0];
        ARRAY_[I3-1] := ARRAY_[I3REV-1];
        ARRAY_[I3+0] := ARRAY_[I3REV+0];
        ARRAY_[I3REV-1] := TEMPR;
        ARRAY_[I3REV+0] := TEMPI;
_20:
        inc(I3,IP2);
       end;
_30:
      inc(I1,2);
     end;
_40:
    IBIT := Trunc( IP2/2 );
_50:
    if ( (IBIT >= IP1) ) and ( (I2REV > IBIT) ) 
     then goto _60;
    goto _70;
_60:
    I2REV := I2REV-IBIT;
    IBIT := Trunc( IBIT/2 );
    goto _50;
_70:
    I2REV := I2REV+IBIT;
_80:
    inc(I2,IP1);
   end;
  IFP1 := IP1;
_90:
  if ( IFP1 >= IP2 ) 
   then goto _130;
  IFP2 := Trunc( 2*IFP1 );
  THETA := IREG*SYS003/(IFP2/IP1);
  WPR := -2.0e0*IntPower(Sin(0.5e0*THETA),2);
  WPI := Sin(THETA);
  WR := 1.0e0;
  WI := 0.0e0;
  I3 := 1;
  while ( I3<=IFP1 ) do
   begin
    I3IP1 := I3+IP1-2;
    I1 := I3;
    while ( I1<=I3IP1 ) do
     begin
      I2 := I1;
      while ( I2<=IP3 ) do
       begin
        K1 := I2;
        K2 := K1+IFP1;
        TEMPR := (WR)*ARRAY_[K2-1]-(WI)*ARRAY_[K2+0];
        TEMPI := (WR)*ARRAY_[K2+0]+(WI)*ARRAY_[K2-1];
        ARRAY_[K2-1] := ARRAY_[K1-1]-TEMPR;
        ARRAY_[K2+0] := ARRAY_[K1+0]-TEMPI;
        ARRAY_[K1-1] := ARRAY_[K1-1]+TEMPR;
        ARRAY_[K1+0] := ARRAY_[K1+0]+TEMPI;
_100:
        inc(I2,IFP2);
       end;
_110:
      inc(I1,2);
     end;
    WTEMP := WR;
    WR := WR*WPR-WI*WPI+WR;
    WI := WI*WPR+WTEMP*WPI+WI;
_120:
    inc(I3,IP1);
   end;
  IFP1 := IFP2;
  goto _90;
_130:
  NPREV := Trunc( N*NPREV );
_140:
 end;
if ( IREG = 1 ) 
 then goto _160;
N := Trunc( 2*NTOT );
TEMP := 1.0/(NTOT);
for I1:=1 to N do
 begin
  ARRAY_[I1-1] := TEMP*ARRAY_[I1-1];
_150:
 end;
_160:
end;

end.
